{"revision":"c10276e953456835cdbb1f3a60d58ae1980be353","document":{"id":506,"path":"api-reference/rest-apis/devops-config-api.md","title":"DevOps Config API","bundle":null,"doc_type":null,"release":"australia","body":"\n# DevOps Config API\n\nThe DevOps Config API provides endpoints to manage your applications.\n\nThis API requires the DevOps Config application and is provided within the `sn_devops_config` namespace.\n\nFor DELETE, PATCH, and POST operations, the calling user must have the sn\\_devops\\_config.admin role. For GET operations, the calling user must have the sn\\_devops\\_config.viewer or sn\\_devops\\_config.admin role.\n\nUse the DevOps Config API for application life cycle management. For more information about managing applications with DevOps Config, see [Configuring DevOps Config](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/it-service-management/setting-up-devops-config-validation.md).\n\n**Parent Topic:**[REST API reference](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-apis/api-rest.md)\n\n## DevOps Config - DELETE /devops\\_config/application/\\{appid\\}\n\nDeletes an application.\n\n### URL format\n\nVersioned URL: `/api/sn_devops_config/{api_version}/devops_config/application/{appid}`\n\nDefault URL: `/api/sn_devops_config/devops_config/application/{appid}`\n\n**Note:** Available versions are specified in the [REST API Explorer](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/use-REST-API-Explorer.md). For scripted REST APIs there is additional version information on the [Scripted REST Service form](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/c_CustomWebServices.md).\n\n### Supported request parameters\n\n<table class=\"rest_api_path_parameters\"><thead><tr><th>\n\nName\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\napi\\_version\n\n</td><td id=\"version-entry-RESTAPI\">\n\nOptional. Version of the endpoint to access. For example, `v1` or `v2`. Only specify this value to use an endpoint version other than the latest. Data type: String\n\n</td></tr><tr><td>\n\nappid\n\n</td><td>\n\nSys\\_id of the application to delete.Data type: String\n\nTable: CDM Application \\[sn\\_cdm\\_application\\]\n\n</td></tr></tbody>\n</table>|Name|Description|\n|----|-----------|\n|None| |\n\n|Name|Description|\n|----|-----------|\n|None| |\n\n### Headers\n\nThe following request and response headers apply to this HTTP action only, or apply to this action in a distinct way. For a list of general headers used in the REST API, see [Supported REST API headers](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/c_RESTAPI.md).\n\n|Header|Description|\n|------|-----------|\n|Accept|Data format of the response body. Only supports **application/json**.|\n\n|Header|Description|\n|------|-----------|\n|None| |\n\n### Status codes\n\nThe following status codes apply to this HTTP action. For a list of possible status codes used in the REST API, see [REST API HTTP response codes](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/c_RESTAPI.md).\n\n|Status code|Description|\n|-----------|-----------|\n|200|Successful. The request was successfully processed.|\n|400|Bad request. Invalid application id.|\n|403|Forbidden. The user doesn't have permission to access the API.|\n\n### Response body parameters \\(JSON\\)\n\n<table id=\"table_z3v_z5d_gvb\"><thead><tr><th>\n\nName\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\nerror\n\n</td><td>\n\nError information. This parameter is only returned if the request failed.Data type: Object\n\n```\n\"error\": {  \n   \"detail\": \"String\",\n   \"message\": \"String\"\n}\n```\n\n</td></tr><tr><td>\n\nerror.detail\n\n</td><td>\n\nAdditional details about why the request failed.Data type: String\n\n</td></tr><tr><td>\n\nerror.message\n\n</td><td>\n\nError message containing the reason the request failed.Data type: String\n\n</td></tr><tr><td>\n\nresult\n\n</td><td>\n\nResult object containing information about the request.Data type: Object\n\n ```\n\"result\": { \n   \"errors\": [Array], \n   \"success\": [Array] \n}\n```\n\n</td></tr><tr><td>\n\nresult.errors\n\n</td><td>\n\nArray of errors from the request. The array is empty for successful requests.Data type: Array\n\n</td></tr><tr><td>\n\nresult.success\n\n</td><td>\n\nSuccess message for the request. The array is empty for failed requests.Data type: Array\n\n</td></tr><tr><td>\n\nstatus\n\n</td><td>\n\nStatus of the request. This parameter is only returned if the request failed.Possible value: failure\n\nData type: String\n\n</td></tr></tbody>\n</table>### cURL request\n\nThis example deletes an application.\n\n```\ncurl \"https://instance.service-now.com/api/sn_devops_config/devops_config/application/38e17dc3473d111072566862736d43c7\" \\ \n--request DELETE \\ \n--header \"Accept:application/json\" \\ \n--user 'username':'password' \n```\n\nResponse body.\n\n```\n{ \n  \"result\": { \n    \"errors\": [], \n    \"success\": [ \n      \"CDM Application Demo Application 1234 has been deleted successfully.\" \n    ] \n  } \n}\n```\n\n### cURL request\n\nThis example shows an error response when a user doesn't have permission to access the API.\n\n```\ncurl \"https://instance.service-now.com/api/sn_devops_config/devops_config/application/38e17dc3473d111072566862736d43c7\" \\ \n--request DELETE \\ \n--header \"Accept:application/json\" \\ \n--user 'username':'password' \n```\n\nError response.\n\n```\n{ \n  \"error\": { \n    \"message\": \"User Not Authorized\", \n    \"detail\": \"Failed API level ACL Validation\" \n  }, \n  \"status\": \"failure\" \n}\n```\n\n## DevOps Config - GET /devops\\_config/application/\\{appid\\}\n\nRetrieves an application.\n\n### URL format\n\nVersioned URL: `/api/sn_devops_config/{api_version}/devops_config/application/{appid}`\n\nDefault URL: `/api/sn_devops_config/devops_config/application/{appid}`\n\n**Note:** Available versions are specified in the [REST API Explorer](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/use-REST-API-Explorer.md). For scripted REST APIs there is additional version information on the [Scripted REST Service form](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/c_CustomWebServices.md).\n\n### Supported request parameters\n\n<table class=\"rest_api_path_parameters\"><thead><tr><th>\n\nName\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\napi\\_version\n\n</td><td id=\"version-entry-RESTAPI\">\n\nOptional. Version of the endpoint to access. For example, `v1` or `v2`. Only specify this value to use an endpoint version other than the latest. Data type: String\n\n</td></tr><tr><td>\n\nappid\n\n</td><td>\n\nSys\\_id of the application to retrieve.Data type: String\n\nTable: CDM Application \\[sn\\_cdm\\_application\\]\n\n</td></tr></tbody>\n</table>|Name|Description|\n|----|-----------|\n|None| |\n\n|Name|Description|\n|----|-----------|\n|None| |\n\n### Headers\n\nThe following request and response headers apply to this HTTP action only, or apply to this action in a distinct way. For a list of general headers used in the REST API, see [Supported REST API headers](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/c_RESTAPI.md).\n\n|Header|Description|\n|------|-----------|\n|Accept|Data format of the response body. Only supports **application/json**.|\n\n|Header|Description|\n|------|-----------|\n|None| |\n\n### Status codes\n\nThe following status codes apply to this HTTP action. For a list of possible status codes used in the REST API, see [REST API HTTP response codes](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/c_RESTAPI.md).\n\n|Status code|Description|\n|-----------|-----------|\n|200|Successful. The request was successfully processed.|\n|400|Bad request. Invalid application id.|\n|403|Forbidden. The user doesn't have permission to access the API.|\n\n### Response body parameters \\(JSON\\)\n\n<table id=\"table_z3v_z5d_gvb\"><thead><tr><th>\n\nName\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\nerror\n\n</td><td>\n\nError information. This parameter is only returned if the request failed.Data type: Object\n\n```\n\"error\": {  \n   \"detail\": \"String\",\n   \"message\": \"String\"\n}\n```\n\n</td></tr><tr><td>\n\nerror.detail\n\n</td><td>\n\nAdditional details about why the request failed.Data type: String\n\n</td></tr><tr><td>\n\nerror.message\n\n</td><td>\n\nError message containing the reason the request failed.Data type: String\n\n</td></tr><tr><td>\n\nresult\n\n</td><td>\n\nResult object containing information about the request.Data type: Object\n\n```\n\"result\": { \n  \"data\": {Object},\n  \"message\": \"String\",\n  \"status\": Number\n}\n```\n\n</td></tr><tr><td>\n\nresult.data\n\n</td><td>\n\nData for the application.Data type: Object\n\n```\n\"data\": { \n  \"appDescription\": \"String\", \n  \"appId\": \"String\",\n  \"appManagedByGroups\": [Array],\n  \"appManufacturerId\": \"String\", \n  \"appManufacturerName\": \"String\", \n  \"appModelId\": \"String\", \n  \"appModelName\": \"String\", \n  \"appModelOwnerId\": \"String\", \n  \"appModelOwnerName\": \"String\", \n  \"appName\": \"String\", \n  \"sdlcType\": \"String\"\n}\n```\n\n</td></tr><tr><td>\n\nresult.data.appDescription\n\n</td><td>\n\nDescription of the application.Data type: String\n\n</td></tr><tr><td>\n\nresult.data.appId\n\n</td><td>\n\nSys\\_id of the application.Data type: String\n\nTable: CDM Application \\[sn\\_cdm\\_application\\]\n\n</td></tr><tr><td>\n\nresult.data.appManagedByGroups\n\n</td><td>\n\nComma-separated list of sys\\_ids of the groups that manage the application.Data type: String\n\nTable: Group \\[sys\\_user\\_group\\]\n\n</td></tr><tr><td>\n\nresult.data.appManufacturerId\n\n</td><td>\n\nSys\\_id of the manufacturer.Data type: String\n\nTable: Company \\[core\\_company\\]\n\n</td></tr><tr><td>\n\nresult.data.appManufacturerName\n\n</td><td>\n\nName of the manufacturer.Data type: String\n\n</td></tr><tr><td>\n\nresult.data.appModelId\n\n</td><td>\n\nSys\\_id of the application model.Data type: String\n\nTable: Application Model \\[cmdb\\_application\\_product\\_model\\]\n\n</td></tr><tr><td>\n\nresult.data.appModelName\n\n</td><td>\n\nName of the application model.Data type: String\n\nTable: Application Model \\[cmdb\\_application\\_product\\_model\\]\n\n</td></tr><tr><td>\n\nresult.data.appModelOwnerId\n\n</td><td>\n\nSys\\_id of the application model owner.Data type: String\n\nTable: User \\[sys\\_user\\]\n\n</td></tr><tr><td>\n\nresult.data.appModelOwnerName\n\n</td><td>\n\nName of the application model owner.Data type: String\n\n</td></tr><tr><td>\n\nresult.data.appName\n\n</td><td>\n\nName of the application.Data type: String\n\n</td></tr><tr><td>\n\nresult.data.error\n\n</td><td>\n\nError information. This parameter is only returned if the request failed.Data type: String\n\n</td></tr><tr><td>\n\nresult.data.sdlcType\n\n</td><td>\n\nType of application.Possible values:\n\n-   application\n-   infrastructure\n\nData type: String\n\n</td></tr><tr><td>\n\nresult.message\n\n</td><td>\n\nInformation about the successful or unsuccessful outcome of the request.Data type: String\n\n</td></tr><tr><td>\n\nresult.status\n\n</td><td>\n\nStatus code for the request.Possible values:\n\n-   200\n-   400\n-   403\n\nData type: Number\n\n</td></tr><tr><td>\n\nstatus\n\n</td><td>\n\nStatus of the request. This parameter is only returned if the request failed.Possible value: failure\n\nData type: String\n\n</td></tr></tbody>\n</table>### cURL request\n\nThis example retrieves an application.\n\n```\ncurl \"https://instance.service-now.com/api/sn_devops_config/devops_config/application/38e17dc3473d111072566862736d43c7\" \\ \n--request GET \\ \n--header \"Accept:application/json\" \\ \n--user 'username':'password' \n```\n\nResponse body.\n\n```\n{ \n  \"result\": { \n    \"status\": 200, \n    \"message\": \"Success\", \n    \"data\": { \n      \"appName\": \"Demo Application 1234\", \n      \"appId\": \"38e17dc3473d111072566862736d43c7\", \n      \"appDescription\": \"Updated description of Demo Application created from REST API\", \n      \"sdlcType\": \"application\", \n      \"appModelId\": \"a4e13dc3473d111072566862736d4307\", \n      \"appModelName\": \"Demo Application 1234\", \n      \"appManufacturerId\": \"262702654725d950a34a3085d36d435e\", \n      \"appManufacturerName\": \"\", \n      \"appModelOwnerId\": \"6816f79cc0a8016401c5a33be04be441\", \n      \"appModelOwnerName\": \"System Administrator\", \n      \"appManagedByGroups\": [] \n    } \n  } \n}\n```\n\n### cURL request\n\nThis example shows an error response when a user provides an invalid application id.\n\n```\ncurl \"https://instance.service-now.com/api/sn_devops_config/devops_config/application/18a17de3283d15107256686277777777\" \\ \n--request GET \\ \n--header \"Accept:application/json\" \\ \n--user 'username':'password' \n```\n\nError response.\n\n```\n{ \n  \"result\": { \n    \"status\": 400, \n    \"message\": \"No valid Application\", \n    \"data\": { \n      \"error\": \"No valid Application\" \n    } \n  } \n}\n```\n\n## DevOps Config - PATCH /devops\\_config/application/\\{appid\\}\n\nUpdates an application.\n\n### URL format\n\nVersioned URL: `/api/sn_devops_config/{api_version}/devops_config/application/{appid}`\n\nDefault URL: `/api/sn_devops_config/devops_config/application/{appid}`\n\n**Note:** Available versions are specified in the [REST API Explorer](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/use-REST-API-Explorer.md). For scripted REST APIs there is additional version information on the [Scripted REST Service form](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/c_CustomWebServices.md).\n\n### Supported request parameters\n\n<table class=\"rest_api_path_parameters\"><thead><tr><th>\n\nName\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\napi\\_version\n\n</td><td id=\"version-entry-RESTAPI\">\n\nOptional. Version of the endpoint to access. For example, `v1` or `v2`. Only specify this value to use an endpoint version other than the latest. Data type: String\n\n</td></tr><tr><td>\n\nappid\n\n</td><td>\n\nSys\\_id of the application to update.Data type: String\n\nTable: CDM Application \\[sn\\_cdm\\_application\\]\n\n</td></tr></tbody>\n</table>|Name|Description|\n|----|-----------|\n|None| |\n\n<table class=\"rest_api_request_body\"><thead><tr><th>\n\nName\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\nappDescription\n\n</td><td id=\"app-descr\">\n\nDescription of the application.Data type: String\n\n</td></tr><tr><td>\n\nappManagedByGroups\n\n</td><td>\n\nComma-separated list of sys\\_ids of the groups that manage the application. The calling user must belong to these groups.```\n\"appManagedByGroups\": \"sys_id, sys_id\" \n```\n\nData type: String\n\nTable: Group \\[sys\\_user\\_group\\]\n\n</td></tr><tr><td>\n\nappManufacturerId\n\n</td><td id=\"app-mfct\">\n\nSys\\_id of the manufacturer.Data type: String\n\nTable: Company \\[core\\_company\\]\n\n</td></tr><tr><td>\n\nappModelOwnerId\n\n</td><td id=\"app-owner-id\">\n\nSys\\_id of the application model owner.Data type: String\n\nTable: User \\[sys\\_user\\]\n\n</td></tr></tbody>\n</table>### Headers\n\nThe following request and response headers apply to this HTTP action only, or apply to this action in a distinct way. For a list of general headers used in the REST API, see [Supported REST API headers](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/c_RESTAPI.md).\n\n|Header|Description|\n|------|-----------|\n|Accept|Data format of the response body. Only supports **application/json**.|\n|Content-Type|Data format of the request body. Only supports **application/json**.|\n\n|Header|Description|\n|------|-----------|\n|None| |\n\n### Status codes\n\nThe following status codes apply to this HTTP action. For a list of possible status codes used in the REST API, see [REST API HTTP response codes](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/c_RESTAPI.md).\n\n|Status code|Description|\n|-----------|-----------|\n|200|Application successfully updated.|\n|403|Forbidden. The user doesn't have permission to access the API.|\n|404|Application not updated. The **message** property in the **result** object contains additional information about the error.|\n\n### Response body parameters \\(JSON\\)\n\n<table id=\"table_z3v_z5d_gvb\"><thead><tr><th>\n\nName\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\nerror\n\n</td><td>\n\nError information. This parameter is only returned if the request failed.Data type: Object\n\n```\n\"error\": {  \n   \"detail\": \"String\",\n   \"message\": \"String\"\n}\n```\n\n</td></tr><tr><td>\n\nerror.detail\n\n</td><td>\n\nAdditional details about why the request failed.Data type: String\n\n</td></tr><tr><td>\n\nerror.message\n\n</td><td>\n\nError message containing the reason the request failed.Data type: String\n\n</td></tr><tr><td>\n\nresult\n\n</td><td>\n\nResult object containing information about the application.Data type: Object\n\n```\n\"result\": { \n   \"data\": \"String\",\n   \"message\": \"String\"\n}\n```\n\n</td></tr><tr><td>\n\nresult.data\n\n</td><td>\n\nSys\\_id of the application.Data type: String\n\nTable: CDM Application \\[sn\\_cdm\\_application\\]\n\n</td></tr><tr><td>\n\nresult.message\n\n</td><td>\n\nInformation about the successful or unsuccessful outcome of the request.Data type: String\n\n</td></tr><tr><td>\n\nstatus\n\n</td><td>\n\nStatus of the request. This parameter is only returned if the request failed.Possible value: failure\n\nData type: String\n\n</td></tr></tbody>\n</table>### cURL request\n\nThis example updates an existing application.\n\n```\ncurl \"https://instance.service-now.com/api/sn_devops_config/devops_config/application/38e17dc3473d111072566862736d43c7\" \\ \n--request PATCH \\ \n--header \"Accept:application/json\" \\ \n--header \"Content-Type:application/json\" \\ \n--data \"{ \n  \\\"appDescription\\\": \\\"Updated description of Demo Application created from REST API\\\", \n  \\\"appManufacturerId\\\": \\\"262702654725d950a34a3085d36d435e\\\", \n  \\\"appModelOwnerId\\\": \\\"6816f79cc0a8016401c5a33be04be441\\\" \n}\" \\ \n--user 'username':'password' \n```\n\nResponse body.\n\n```\n{ \n  \"result\": { \n    \"message\": \"Application with name Demo Application 1234 updated successfully.\", \n    \"data\": \"38e17dc3473d111072566862736d43c7\" \n  } \n}\n```\n\n## DevOps Config - POST /devops\\_config/application\n\nCreates an application.\n\n### URL format\n\nVersioned URL: `/api/sn_devops_config/{api_version}/devops_config/application`\n\nDefault URL: `/api/sn_devops_config/devops_config/application`\n\n**Note:** Available versions are specified in the [REST API Explorer](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/use-REST-API-Explorer.md). For scripted REST APIs there is additional version information on the [Scripted REST Service form](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/c_CustomWebServices.md).\n\n### Supported request parameters\n\n<table class=\"rest_api_path_parameters\"><thead><tr><th>\n\nName\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\napi\\_version\n\n</td><td id=\"version-entry-RESTAPI\">\n\nOptional. Version of the endpoint to access. For example, `v1` or `v2`. Only specify this value to use an endpoint version other than the latest. Data type: String\n\n</td></tr></tbody>\n</table>|Name|Description|\n|----|-----------|\n|None| |\n\n<table class=\"rest_api_request_body\"><thead><tr><th>\n\nName\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\nappDescription\n\n</td><td id=\"app-descr\">\n\nDescription of the application.Data type: String\n\n</td></tr><tr><td>\n\nappManagedByGroups\n\n</td><td>\n\nComma-separated list of sys\\_ids of the groups that manage the application. The calling user must belong to these groups.```\n\"appManagedByGroups\": \"sys_id, sys_id\" \n```\n\nData type: String\n\nTable: Group \\[sys\\_user\\_group\\]\n\n</td></tr><tr><td>\n\nappManufacturerId\n\n</td><td id=\"app-mfct\">\n\nSys\\_id of the manufacturer.Data type: String\n\nTable: Company \\[core\\_company\\]\n\n</td></tr><tr><td>\n\nappModelId\n\n</td><td>\n\nSys\\_id of an existing application model to use to create the application.If this parameter is provided, don't provide the **appName**, **appModelName**, **appServiceName**, **appServiceId**, or **technicalServiceId** parameters.\n\nData type: String\n\nTable:Application Model \\[cmdb\\_application\\_product\\_model\\]\n\n</td></tr><tr><td>\n\nappModelName\n\n</td><td>\n\nName of an existing application model to use to create the application. If this parameter is provided, don't provide the **appName**, **appModelId**, **appServiceName**, **appServiceId**, or **technicalServiceId** parameters.\n\nData type: String\n\nTable: Application Model \\[cmdb\\_application\\_product\\_model\\]\n\n</td></tr><tr><td>\n\nappModelOwnerId\n\n</td><td id=\"app-owner-id\">\n\nSys\\_id of the application model owner.Data type: String\n\nTable: User \\[sys\\_user\\]\n\n</td></tr><tr><td>\n\nappName\n\n</td><td>\n\nName of the application.Don't use the same name as any existing application.\n\nIf this parameter is provided, don't provide the **appModelName**, **appModelId**, **appServiceName**, **appServiceId**, or **technicalServiceId** parameters.\n\nData type: String\n\n</td></tr><tr><td>\n\nappServiceId\n\n</td><td>\n\nSys\\_id of an existing application service to use to create the application.Use this parameter only when the **type** is `application`.\n\nIf this parameter is provided, don't provide the **appName**, **appModelName**, **appModelId**, **appServiceName**, or **technicalServiceId** parameters.\n\nData type: String\n\nTable: Service Instance \\[cmdb\\_ci\\_service\\_auto\\]\n\n</td></tr><tr><td>\n\nappServiceName\n\n</td><td>\n\nName of an existing application service to use to create the application.Use this parameter only when the **type** is `application`.\n\nIf this parameter is provided, don't provide the **appName**, **appModelName**, **appModelId**, **appServiceId**, or **technicalServiceId** parameters.\n\nData type: String\n\nTable: Service Instance \\[cmdb\\_ci\\_service\\_auto\\]\n\n</td></tr><tr><td>\n\ntechnicalServiceId\n\n</td><td>\n\nSys\\_id of an existing dynamic CI group to use to create the application.Use this parameter only when the **type** is `infrastructure`.\n\nIf this parameter is provided, don't provide the **appName**, **appModelName**, **appModelId**, **appServiceName**, or **appServiceId** parameters.\n\nData type: String\n\nTable: Dynamic CI Group \\[cmdb\\_ci\\_query\\_based\\_service\\]\n\n</td></tr><tr><td>\n\ntype\n\n</td><td>\n\nRequired. The type of application to create.Valid values:\n\n-   application\n-   infrastructure\n\nData type: String\n\n</td></tr></tbody>\n</table>### Headers\n\nThe following request and response headers apply to this HTTP action only, or apply to this action in a distinct way. For a list of general headers used in the REST API, see [Supported REST API headers](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/c_RESTAPI.md).\n\n|Header|Description|\n|------|-----------|\n|Accept|Data format of the response body. Only supports **application/json**.|\n|Content-Type|Data format of the request body. Only supports **application/json**.|\n\n|Header|Description|\n|------|-----------|\n|None| |\n\n### Status codes\n\nThe following status codes apply to this HTTP action. For a list of possible status codes used in the REST API, see [REST API HTTP response codes](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/c_RESTAPI.md).\n\n|Status code|Description|\n|-----------|-----------|\n|201|Application successfully created.|\n|403|Forbidden. The user doesn't have permission to access the API.|\n|404|Application not created. The **message** property in the **result** object contains additional information about the error.|\n\n### Response body parameters \\(JSON\\)\n\n<table id=\"table_z3v_z5d_gvb\"><thead><tr><th>\n\nName\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\nerror\n\n</td><td>\n\nError information. This parameter is only returned if the request failed.Data type: Object\n\n```\n\"error\": {  \n   \"detail\": \"String\",\n   \"message\": \"String\"\n}\n```\n\n</td></tr><tr><td>\n\nerror.detail\n\n</td><td>\n\nAdditional details about why the request failed.Data type: String\n\n</td></tr><tr><td>\n\nerror.message\n\n</td><td>\n\nError message containing the reason the request failed.Data type: String\n\n</td></tr><tr><td>\n\nresult\n\n</td><td>\n\nResult object containing information about the application.Data type: Object\n\n```\n\"result\": { \n   \"data\": \"String\",\n   \"message\": \"String\"\n}\n```\n\n</td></tr><tr><td>\n\nresult.data\n\n</td><td>\n\nSys\\_id of the application.Data type: String\n\nTable: CDM Application \\[sn\\_cdm\\_application\\]\n\n</td></tr><tr><td>\n\nresult.message\n\n</td><td>\n\nInformation about the successful or unsuccessful outcome of the request.Data type: String\n\n</td></tr><tr><td>\n\nstatus\n\n</td><td>\n\nStatus of the request. This parameter is only returned if the request failed.Possible value: failure\n\nData type: String\n\n</td></tr></tbody>\n</table>### cURL request\n\nThis example shows how to create a new application.\n\n```\ncurl \"https://instance.service-now.com/api/sn_devops_config/devops_config/application\" \\ \n--request POST \\ \n--header \"Accept:application/json\" \\ \n--header \"Content-Type:application/json\" \\ \n--data \"{ \n  \\\"type\\\": \\\"application\\\", \n  \\\"appName\\\": \\\"Demo Application 1234\\\", \n  \\\"appDescription\\\": \\\"Description of Demo Application created from REST API\\\", \n  \\\"appManufacturerId\\\": \\\"262702654725d950a34a3085d36d435e\\\", \n  \\\"appModelOwnerId\\\": \\\"6816f79cc0a8016401c5a33be04be441\\\" \n}\" \\ \n--user 'username':'password' \n```\n\nResponse body.\n\n```\n{ \n  \"result\": { \n    \"message\": \"Application with name Demo Application 1234 created successfully.\", \n    \"data\": \"38e17dc3473d111072566862736d43c7\" \n  } \n} \n```\n\n"}}